(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('plotly.js/dist/plotly.min.js')) :
    typeof define === 'function' && define.amd ? define('angular-plotly.js', ['exports', '@angular/common', '@angular/core', 'plotly.js/dist/plotly.min.js'], factory) :
    (factory((global['angular-plotly'] = global['angular-plotly'] || {}, global['angular-plotly'].js = {}),global.ng.common,global.ng.core,global.Plotlyjs));
}(this, (function (exports,common,core,Plotlyjs) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Plotly;
    (function (Plotly) {
        /**
         * @record
         */
        function Figure() { }
        Plotly.Figure = Figure;
        /**
         * @record
         */
        function PlotlyHTMLElement() { }
        Plotly.PlotlyHTMLElement = PlotlyHTMLElement;
    })(Plotly || (Plotly = {}));
    var PlotlyService = /** @class */ (function () {
        function PlotlyService() {
            if (typeof this.getPlotly() === 'undefined') {
                throw new Error("Peer dependency plotly.js isn't installed");
            }
        }
        /**
         * @param {?} instance
         * @return {?}
         */
        PlotlyService.insert = /**
         * @param {?} instance
         * @return {?}
         */
            function (instance) {
                /** @type {?} */
                var index = PlotlyService.instances.indexOf(instance);
                if (index === -1) {
                    PlotlyService.instances.push(instance);
                }
                return instance;
            };
        /**
         * @param {?} div
         * @return {?}
         */
        PlotlyService.remove = /**
         * @param {?} div
         * @return {?}
         */
            function (div) {
                /** @type {?} */
                var index = PlotlyService.instances.indexOf(div);
                if (index >= 0) {
                    PlotlyService.instances.splice(index, 1);
                }
            };
        /**
         * @return {?}
         */
        PlotlyService.prototype.getPlotly = /**
         * @return {?}
         */
            function () {
                return Plotlyjs;
            };
        /**
         * @param {?} div
         * @param {?} data
         * @param {?=} layout
         * @param {?=} config
         * @return {?}
         */
        PlotlyService.prototype.newPlot = /**
         * @param {?} div
         * @param {?} data
         * @param {?=} layout
         * @param {?=} config
         * @return {?}
         */
            function (div, data, layout, config) {
                return this.getPlotly().newPlot(div, data, layout, config).then(function (instance) { return PlotlyService.insert(instance); });
            };
        /**
         * @param {?} div
         * @param {?} data
         * @param {?=} layout
         * @param {?=} config
         * @return {?}
         */
        PlotlyService.prototype.plot = /**
         * @param {?} div
         * @param {?} data
         * @param {?=} layout
         * @param {?=} config
         * @return {?}
         */
            function (div, data, layout, config) {
                return this.getPlotly().plot(div, data, layout, config);
            };
        /**
         * @param {?} div
         * @param {?} data
         * @param {?=} layout
         * @param {?=} config
         * @return {?}
         */
        PlotlyService.prototype.update = /**
         * @param {?} div
         * @param {?} data
         * @param {?=} layout
         * @param {?=} config
         * @return {?}
         */
            function (div, data, layout, config) {
                return this.getPlotly().react(div, data, layout, config);
            };
        /**
         * @param {?} div
         * @return {?}
         */
        PlotlyService.prototype.resize = /**
         * @param {?} div
         * @return {?}
         */
            function (div) {
                return this.getPlotly().Plots.resize(div);
            };
        PlotlyService.instances = [];
        PlotlyService.decorators = [
            { type: core.Injectable }
        ];
        /** @nocollapse */
        PlotlyService.ctorParameters = function () { return []; };
        return PlotlyService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // @dynamic
    var PlotComponent = /** @class */ (function () {
        function PlotComponent(plotly, iterableDiffers, keyValueDiffers) {
            this.plotly = plotly;
            this.iterableDiffers = iterableDiffers;
            this.keyValueDiffers = keyValueDiffers;
            this.defaultClassName = 'js-plotly-plot';
            this.revision = 0;
            this.debug = false;
            this.useResizeHandler = false;
            this.initialized = new core.EventEmitter();
            this.update = new core.EventEmitter();
            this.purge = new core.EventEmitter();
            this.error = new core.EventEmitter();
            this.afterExport = new core.EventEmitter();
            this.afterPlot = new core.EventEmitter();
            this.animated = new core.EventEmitter();
            this.animatingFrame = new core.EventEmitter();
            this.animationInterrupted = new core.EventEmitter();
            this.autoSize = new core.EventEmitter();
            this.beforeExport = new core.EventEmitter();
            this.buttonClicked = new core.EventEmitter();
            this.click = new core.EventEmitter();
            this.clickAnnotation = new core.EventEmitter();
            this.deselect = new core.EventEmitter();
            this.doubleClick = new core.EventEmitter();
            this.framework = new core.EventEmitter();
            this.hover = new core.EventEmitter();
            this.legendClick = new core.EventEmitter();
            this.legendDoubleClick = new core.EventEmitter();
            this.relayout = new core.EventEmitter();
            this.restyle = new core.EventEmitter();
            this.redraw = new core.EventEmitter();
            this.selected = new core.EventEmitter();
            this.selecting = new core.EventEmitter();
            this.sliderChange = new core.EventEmitter();
            this.sliderEnd = new core.EventEmitter();
            this.sliderStart = new core.EventEmitter();
            this.transitioning = new core.EventEmitter();
            this.transitionInterrupted = new core.EventEmitter();
            this.unhover = new core.EventEmitter();
            this.eventNames = ['afterExport', 'afterPlot', 'animated', 'animatingFrame', 'animationInterrupted', 'autoSize',
                'beforeExport', 'buttonClicked', 'click', 'clickAnnotation', 'deselect', 'doubleClick', 'framework', 'hover',
                'legendClick', 'legendDoubleClick', 'relayout', 'restyle', 'redraw', 'selected', 'selecting', 'sliderChange',
                'sliderEnd', 'sliderStart', 'transitioning', 'transitionInterrupted', 'unhover'];
        }
        /**
         * @return {?}
         */
        PlotComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                var _this = this;
                this.createPlot().then(function () {
                    /** @type {?} */
                    var figure = _this.createFigure();
                    _this.initialized.emit(figure);
                });
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                if (typeof this.resizeHandler === 'function') {
                    this.getWindow().removeEventListener('resize', ( /** @type {?} */(this.resizeHandler)));
                    this.resizeHandler = undefined;
                }
                /** @type {?} */
                var figure = this.createFigure();
                this.purge.emit(figure);
                PlotlyService.remove(this.plotlyInstance);
            };
        /**
         * @param {?} changes
         * @return {?}
         */
        PlotComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
            function (changes) {
                /** @type {?} */
                var shouldUpdate = false;
                /** @type {?} */
                var revision = changes.revision;
                if (revision && !revision.isFirstChange()) {
                    shouldUpdate = true;
                }
                /** @type {?} */
                var debug = changes.debug;
                if (debug && !debug.isFirstChange()) {
                    shouldUpdate = true;
                }
                if (shouldUpdate) {
                    this.updatePlot();
                }
                this.updateWindowResizeHandler();
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.ngDoCheck = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var shouldUpdate = false;
                if (this.layoutDiffer) {
                    /** @type {?} */
                    var layoutHasDiff = this.layoutDiffer.diff(this.layout);
                    if (layoutHasDiff) {
                        shouldUpdate = true;
                    }
                }
                else if (this.layout) {
                    this.layoutDiffer = this.keyValueDiffers.find(this.layout).create();
                }
                else {
                    this.layoutDiffer = undefined;
                }
                if (this.dataDiffer) {
                    /** @type {?} */
                    var dataHasDiff = this.dataDiffer.diff(this.data);
                    if (dataHasDiff) {
                        shouldUpdate = true;
                    }
                }
                else if (Array.isArray(this.data)) {
                    this.dataDiffer = this.iterableDiffers.find(this.data).create(this.dataDifferTrackBy);
                }
                else {
                    this.dataDiffer = undefined;
                }
                if (shouldUpdate && this.plotlyInstance) {
                    this.updatePlot();
                }
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.getWindow = /**
         * @return {?}
         */
            function () {
                return window;
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.getClassName = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var classes = [this.defaultClassName];
                if (Array.isArray(this.className)) {
                    classes = classes.concat(this.className);
                }
                else if (this.className) {
                    classes.push(this.className);
                }
                return classes.join(' ');
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.createPlot = /**
         * @return {?}
         */
            function () {
                var _this = this;
                return this.plotly.newPlot(this.plotEl.nativeElement, this.data, this.layout, this.config).then(function (plotlyInstance) {
                    _this.plotlyInstance = plotlyInstance;
                    _this.getWindow().gd = _this.debug ? plotlyInstance : undefined;
                    _this.eventNames.forEach(function (name) {
                        /** @type {?} */
                        var eventName = "plotly_" + name.toLowerCase();
                        plotlyInstance.on(eventName, function (data) { return (( /** @type {?} */(_this[name]))).emit(data); });
                    });
                    _this.updateWindowResizeHandler();
                }, function (err) {
                    console.error('Error while plotting:', err);
                    _this.error.emit(err);
                });
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.createFigure = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var p = this.plotlyInstance;
                /** @type {?} */
                var figure = {
                    data: p.data,
                    layout: p.layout,
                    frames: p._transitionData ? p._transitionData._frames : null
                };
                return figure;
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.updatePlot = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (!this.plotlyInstance) {
                    /** @type {?} */
                    var error = new Error("Plotly component wasn't initialized");
                    this.error.emit(error);
                    throw error;
                }
                return this.plotly.update(this.plotlyInstance, this.data, this.layout, this.config).then(function () {
                    /** @type {?} */
                    var figure = _this.createFigure();
                    _this.update.emit(figure);
                }, function (err) {
                    console.error('Error while updating plot:', err);
                    _this.error.emit(err);
                });
            };
        /**
         * @return {?}
         */
        PlotComponent.prototype.updateWindowResizeHandler = /**
         * @return {?}
         */
            function () {
                var _this = this;
                if (this.useResizeHandler) {
                    if (this.resizeHandler === undefined) {
                        this.resizeHandler = function () { return _this.plotly.resize(_this.plotlyInstance); };
                        this.getWindow().addEventListener('resize', ( /** @type {?} */(this.resizeHandler)));
                    }
                }
                else {
                    if (typeof this.resizeHandler === 'function') {
                        this.getWindow().removeEventListener('resize', ( /** @type {?} */(this.resizeHandler)));
                        this.resizeHandler = undefined;
                    }
                }
            };
        /**
         * @param {?} _
         * @param {?} item
         * @return {?}
         */
        PlotComponent.prototype.dataDifferTrackBy = /**
         * @param {?} _
         * @param {?} item
         * @return {?}
         */
            function (_, item) {
                /** @type {?} */
                var obj = Object.assign({}, item, { uid: '' });
                return JSON.stringify(obj);
            };
        PlotComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'plotly-plot',
                        template: "<div #plot [attr.id]=\"divId\" [className]=\"getClassName()\" [ngStyle]=\"style\"></div>",
                        providers: [PlotlyService]
                    }] }
        ];
        /** @nocollapse */
        PlotComponent.ctorParameters = function () {
            return [
                { type: PlotlyService },
                { type: core.IterableDiffers },
                { type: core.KeyValueDiffers }
            ];
        };
        PlotComponent.propDecorators = {
            plotEl: [{ type: core.ViewChild, args: ['plot',] }],
            data: [{ type: core.Input }],
            layout: [{ type: core.Input }],
            config: [{ type: core.Input }],
            style: [{ type: core.Input }],
            divId: [{ type: core.Input }],
            revision: [{ type: core.Input }],
            className: [{ type: core.Input }],
            debug: [{ type: core.Input }],
            useResizeHandler: [{ type: core.Input }],
            initialized: [{ type: core.Output }],
            update: [{ type: core.Output }],
            purge: [{ type: core.Output }],
            error: [{ type: core.Output }],
            afterExport: [{ type: core.Output }],
            afterPlot: [{ type: core.Output }],
            animated: [{ type: core.Output }],
            animatingFrame: [{ type: core.Output }],
            animationInterrupted: [{ type: core.Output }],
            autoSize: [{ type: core.Output }],
            beforeExport: [{ type: core.Output }],
            buttonClicked: [{ type: core.Output }],
            click: [{ type: core.Output }],
            clickAnnotation: [{ type: core.Output }],
            deselect: [{ type: core.Output }],
            doubleClick: [{ type: core.Output }],
            framework: [{ type: core.Output }],
            hover: [{ type: core.Output }],
            legendClick: [{ type: core.Output }],
            legendDoubleClick: [{ type: core.Output }],
            relayout: [{ type: core.Output }],
            restyle: [{ type: core.Output }],
            redraw: [{ type: core.Output }],
            selected: [{ type: core.Output }],
            selecting: [{ type: core.Output }],
            sliderChange: [{ type: core.Output }],
            sliderEnd: [{ type: core.Output }],
            sliderStart: [{ type: core.Output }],
            transitioning: [{ type: core.Output }],
            transitionInterrupted: [{ type: core.Output }],
            unhover: [{ type: core.Output }]
        };
        return PlotComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PlotlyModule = /** @class */ (function () {
        function PlotlyModule() {
        }
        /**
         * @return {?}
         */
        PlotlyModule.forRoot = /**
         * @return {?}
         */
            function () {
                return {
                    ngModule: PlotlyModule,
                    providers: [PlotlyService]
                };
            };
        PlotlyModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [PlotComponent],
                        exports: [PlotComponent]
                    },] }
        ];
        return PlotlyModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.PlotlyModule = PlotlyModule;
    exports.PlotComponent = PlotComponent;
    exports.PlotlyService = PlotlyService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=angular-plotly.js.umd.js.map