export declare namespace Plotly {
    type Data = any;
    type Layout = any;
    type Config = any;
    interface Figure {
        data: Data[];
        layout: Partial<Layout>;
        frames: Partial<Config>;
    }
    interface PlotlyHTMLElement extends HTMLElement {
        on(event: string, callback: Function): void;
        removeListener(event: string, callback: Function): void;
    }
}
export declare class PlotlyService {
    protected static instances: Plotly.PlotlyHTMLElement[];
    constructor();
    static insert(instance: Plotly.PlotlyHTMLElement): Plotly.PlotlyHTMLElement;
    static remove(div: Plotly.PlotlyHTMLElement): void;
    getPlotly(): any;
    newPlot(div: HTMLDivElement, data: Plotly.Data[], layout?: Partial<Plotly.Layout>, config?: Partial<Plotly.Config>): any;
    plot(div: Plotly.PlotlyHTMLElement, data: Plotly.Data[], layout?: Partial<Plotly.Layout>, config?: Partial<Plotly.Config>): any;
    update(div: Plotly.PlotlyHTMLElement, data: Plotly.Data[], layout?: Partial<Plotly.Layout>, config?: Partial<Plotly.Config>): any;
    resize(div: Plotly.PlotlyHTMLElement): void;
}
